<template>
    <MenuBar>
        <div class="main-container flex items-center items-justify" v-loading="loading">
            <div class="flex flex-wrap items-justify">
                <el-card class="cart-card margin-right-sm margin-top-sm">
                    <h2 class="no-margin color-primary">Your orders</h2>
                    <el-row>
                        <template v-for="item in drawerItems">
                            <el-col class="margin-top-sm">
                                <div
                                    class="flex items-center items-space-between"
                                >
                                    <div class="flex items-center">
                                        <img
                                            id="productImg"
                                            :src="
                                                item.img_url.length > 0
                                                    ? `/pictures/${item.img_url}`
                                                    : `/imgs/logo.jpg`
                                            "
                                        />
                                        <div
                                            class="flex flex-column margin-left-sm"
                                        >
                                            <h3 class="no-margin">
                                                {{ item.name }}
                                            </h3>
                                            <div
                                                class="flex items-space-between"
                                            >
                                                <p
                                                    class="no-margin color-red"
                                                    style="width: 70px"
                                                >
                                                    ₱{{ item.price }}
                                                </p>
                                                <p
                                                    class="no-margin"
                                                    style="width: 70px"
                                                >
                                                    Each
                                                </p>
                                            </div>
                                            <div
                                                class="flex items-space-between"
                                            >
                                                <p
                                                    class="no-margin color-red"
                                                    style="width: 70px"
                                                >
                                                    ₱{{ item.subtotal }}
                                                </p>
                                                <p
                                                    class="no-margin"
                                                    style="width: 70px"
                                                >
                                                    Total
                                                </p>
                                            </div>
                                        </div>
                                    </div>
                                    <el-input-number
                                        style="
                                            width: 8rem;
                                            height: 2.5rem;
                                            text-align: center;
                                        "
                                        v-model.number="item.quantity"
                                        @input="updateItemQuantity(item)"
                                        :min="1"
                                    />
                                </div>
                                <el-button
                                    class="drawer-remove-btn margin-top-sm"
                                    size="medium"
                                    @click="removeFromCart(item)"
                                >
                                    REMOVE
                                </el-button>
                            </el-col>
                        </template>
                    </el-row>
                </el-card>

                <el-card
                    v-if="!onlinePaymentProcedure"
                    class="payment-card margin-top-sm flex items-center items-justify"
                >
                    <h2 class="no-margin color-primary">
                        Personal Information
                    </h2>
                    <template v-for="(item, key) in data">
                        <span class="flex margin-top-sm">
                            <h4 class="no-margin margin-right-sm">
                                {{ key }}:
                            </h4>
                            <h4 class="no-margin">{{ item }}</h4>
                        </span>
                    </template>

                    <el-input
                        v-model="comment"
                        type="textarea"
                        placeholder="You can leave a remarks in here"
                        class="comment margin-top-sm margin-bottom-sm"
                    />
                    <hr />

                    <h3>Summary</h3>
                    <el-radio-group v-model="paymentMethod" class="ml-4">
                        <el-radio label="cod" size="large"
                            >Cash on Delivery</el-radio
                        >
                        <el-radio label="gcash" size="large"
                            >Gcash online payment</el-radio
                        >
                    </el-radio-group>

                    <span class="flex margin-top-sm">
                        <h4 class="no-margin margin-right-sm">Sub Total:</h4>
                        <h4 class="no-margin color-red">
                            ₱{{ totalSubtotal[0] }}
                        </h4>
                    </span>

                    <span class="flex margin-top-sm">
                        <h4 class="no-margin margin-right-sm">Shipping fee</h4>
                        <h4 class="no-margin color-red">₱50</h4>
                    </span>

                    <span class="flex margin-top-sm">
                        <h4 class="no-margin margin-right-sm">Total</h4>
                        <h4 class="no-margin color-red">
                            ₱{{ totalSubtotal[1] }}
                        </h4>
                    </span>

                    <el-button
                        class="margin-top-lg"
                        type="success"
                        size="large"
                        :disabled="totalSubtotal[0] < 1"
                        @click="paymentMethod === 'cod' ? placeOrder() : onlinePaymentProceeed()"
                        >{{ paymentMethod == "cod" ? "PLACE ORDER NOW" : "PROCEED TO ONLINE PAYMENT" }}</el-button
                    >
                </el-card>

                <el-card v-if="onlinePaymentProcedure == true" class="payment-card margin-top-sm flex  items-justify" style="overflow:scroll; height:600px;">
                    <el-button type="danger" @click="onlinePaymentProceeed()">Back</el-button>
                    <h2 class="no-margin color-primary margin-bottom-md">
                        Please send your proof of payment first
                    </h2>
                    <img src="/imgs/gcash.jpg" width="350" height="450"/>

                    <p>Please upload your proof of payment in here.</p>
                    <input
                            type="file"
                            id="picture"
                            accept="image/*"
                            @change="handlePictureChange"
                            class="hidden-input"
                        />
                        
                        <br/>
                        <el-button type="success" size="large" class="margin-top-sm" @click="placeOrder()">Place order now</el-button>
                     
                </el-card>
            </div>
        </div>
    </MenuBar>
</template>

<style lang="scss" scoped>
@import "../../../../sass/app.scss";

.comment {
    max-height: 100px;
    overflow: auto;
    resize: none;
}

#productImg {
    object-fit: cover;
    width: 100px;
    height: 100px;
    background-color: rgb(214, 214, 214);
    border-radius: 1rem;
    border: 1px solid rgb(163, 163, 163);
}
.main-container {
    height: 800px;
    width: 100%;
    overflow-x: hidden;
    overflow-y: hidden;
}
.cart-card {
    width: 700px;
}

.payment-card {
    width: 450px;
}

@media (max-width: 768px) {
    .cart-card,
    .payment-card {
        height: auto;
        width: 90%;
    }

    .main-container {
        height: auto;
    }
}

.drawer-remove-btn {
    cursor: pointer;
    width: 100%;
    padding: 1rem;
    background-color: #e84141;
    color: white;
    text-align: center;
}

.drawer-img {
    object-fit: cover;
    width: 100px;
    height: 100px;
    background-color: rgb(214, 214, 214);
    border-radius: 1rem;
    border: 1px solid rgb(163, 163, 163);
}

.el-button {
    color: white;
}
</style>

<script setup>
import { useRoute, useRouter } from "vue-router";
import { onMounted } from "vue";
import { ref } from "vue";
import userHandler from "../../helpers/userHandler";
import { notify } from "../../common/notification";

const drawerItems = ref([]);
const totalSubtotal = ref([]);
const paymentMethod = ref("cod");
const { loading, getUserData } = userHandler;
const data = ref([]);
const comment = ref();
const router = useRouter();
const onlinePaymentProcedure = ref(false);

onMounted(async () => {
    updateDrawerItems();
    updateTotalSubTotal();
    await getUserData(data);

    data.value = Object.entries(data.value).reduce((acc, [key, value]) => {
        if (key === "name" || key === "address" || key === "phone_number") {
            acc[key] = value;
        }
        return acc;
    }, {});
});

const picture = ref(null);

const handlePictureChange = (event) => {
    const file = event.target.files[0];

    picture.value = file;

    // Create a FileReader instance
    const reader = new FileReader();

    // Read the file and generate a preview URL
    reader.onload = () => {
        picturePreview.value = reader.result;
    };

    // Read the file as a data URL
    reader.readAsDataURL(file);
};

const onlinePaymentProceeed = () => {
    onlinePaymentProcedure.value = !onlinePaymentProcedure.value;
}

const updateItemQuantity = (item) => {
    const cartItemsString = sessionStorage.getItem("cart");
    if (cartItemsString) {
        const cartItems = JSON.parse(cartItemsString);
        const existingItemIndex = cartItems.findIndex(
            (cartItem) => cartItem.id === item.id
        );
        if (existingItemIndex !== -1) {
            cartItems[existingItemIndex].quantity = item.quantity;

            cartItems[existingItemIndex].subtotal =
                cartItems[existingItemIndex].quantity *
                cartItems[existingItemIndex].price;

            sessionStorage.setItem("cart", JSON.stringify(cartItems));

            let totalSubtotal = 0;
            cartItems.forEach((cartItem) => {
                totalSubtotal += cartItem.subtotal;
            });

            sessionStorage.setItem("totalSubtotal", totalSubtotal);

            updateDrawerItems();
            updateTotalSubTotal();
        }
    }
};

const removeFromCart = (item) => {
    const cartItemsString = sessionStorage.getItem("cart");
    if (cartItemsString) {
        let cartItems = JSON.parse(cartItemsString);

        const existingItemIndex = cartItems.findIndex(
            (cartItem) => cartItem.id === item.id
        );

        if (existingItemIndex !== -1) {
            cartItems.splice(existingItemIndex, 1);

            sessionStorage.setItem("cart", JSON.stringify(cartItems));

            let totalSubtotal = 0;
            cartItems.forEach((cartItem) => {
                totalSubtotal += cartItem.subtotal;
            });

            sessionStorage.setItem("totalSubtotal", totalSubtotal);
            updateDrawerItems();
            updateTotalSubTotal();
        }
    }
};

const updateDrawerItems = () => {
    drawerItems.value = JSON.parse(sessionStorage.getItem("cart") || null);
};

const updateTotalSubTotal = () => {
    let total = sessionStorage.getItem("totalSubtotal", totalSubtotal) || 0;
    totalSubtotal.value[0] = total;
    totalSubtotal.value[1] = parseInt(total) + 50;
};

const placeOrder = async () => {
    let cartOrders = JSON.parse(sessionStorage.getItem("cart") || null);
    const filteredCartOrders = cartOrders.map((item) => {
        return {
            id: item.id,
            quantity: item.quantity,
        };
    });

    const finalOrder = {
        comment: comment.value,
        paymentMethod: paymentMethod.value,
        orders: filteredCartOrders,
        picture: picture.value,
    };

    try {
        loading.value = true;
        const token =
            localStorage.getItem("user_token") ??
            sessionStorage.getItem("user_token");
        const headers = { 
            Authorization: `Bearer ${token}`,
            "Content-Type":
                picture.value === null ? "application/json" : "multipart/form-data" };
        await axios({
            method: 'POST',
            url: "/api/user/transact",
            data: finalOrder,
            headers: headers,
        });
        notify("Success!", "Your transaction was success.", 1);
        router.push('/')
    } catch (error) {
        notify("Oops!", "Something went wrong.", 4);
        console.log("Ordering error ", error);
    } finally {
        loading.value = false;
    }
};
</script>
